Index: trunk/LMDZ.COMMON/libf/dyn3d/vlsplt.F
===================================================================
--- trunk/LMDZ.COMMON/libf/dyn3d/vlsplt.F	(revision 1507)
+++ trunk/LMDZ.COMMON/libf/dyn3d/vlsplt.F	(revision 1508)
@@ -1,7 +1,8 @@
 c
-c $Id: vlsplt.F 1550 2011-07-05 09:44:55Z lguez $
-c
-
-      SUBROUTINE vlsplt(q,pente_max,masse,w,pbaru,pbarv,pdt)
+c $Id: vlsplt.F 2286 2015-05-20 13:27:07Z emillour $
+c
+
+      SUBROUTINE vlsplt(q,pente_max,masse,w,pbaru,pbarv,pdt,iq)
+      USE infotrac, ONLY: nqtot,nqdesc,iqfils
 c
 c     Auteurs:   P.Le Van, F.Hourdin, F.Forget 
@@ -29,7 +30,8 @@
 c      REAL masse(iip1,jjp1,llm),pente_max
       REAL pbaru( ip1jmp1,llm ),pbarv( ip1jm,llm)
-      REAL q(ip1jmp1,llm)
+      REAL q(ip1jmp1,llm,nqtot)
 c      REAL q(iip1,jjp1,llm)
       REAL w(ip1jmp1,llm),pdt
+      INTEGER iq ! CRisi
 c
 c      Local 
@@ -39,9 +41,9 @@
       INTEGER ijlqmin,iqmin,jqmin,lqmin
 c
-      REAL zm(ip1jmp1,llm),newmasse
+      REAL zm(ip1jmp1,llm,nqtot),newmasse
       REAL mu(ip1jmp1,llm)
       REAL mv(ip1jm,llm)
       REAL mw(ip1jmp1,llm+1)
-      REAL zq(ip1jmp1,llm),zz
+      REAL zq(ip1jmp1,llm,nqtot),zz
       REAL dqx(ip1jmp1,llm),dqy(ip1jmp1,llm),dqz(ip1jmp1,llm)
       REAL second,temps0,temps1,temps2,temps3
@@ -52,4 +54,5 @@
       SAVE temps1,temps2,temps3
       INTEGER iminn,imaxx
+      INTEGER ifils,iq2 ! CRisi
 
       REAL qmin,qmax
@@ -76,27 +79,35 @@
          mw(ij,llm+1)=0.
       ENDDO
-      
-      CALL SCOPY(ijp1llm,q,1,zq,1)
-      CALL SCOPY(ijp1llm,masse,1,zm,1)
+           
+      CALL SCOPY(ijp1llm,q(1,1,iq),1,zq(1,1,iq),1)
+      CALL SCOPY(ijp1llm,masse,1,zm(1,1,iq),1)
+        
+      if (nqdesc(iq).gt.0) then  
+        do ifils=1,nqdesc(iq)
+          iq2=iqfils(ifils,iq)
+          CALL SCOPY(ijp1llm,q(1,1,iq2),1,zq(1,1,iq2),1)
+        enddo  
+      endif !if (nqfils(iq).gt.0) then
 
 cprint*,'Entree vlx1'
 c	call minmaxq(zq,qmin,qmax,'avant vlx     ')
-      call vlx(zq,pente_max,zm,mu)
+      call vlx(zq,pente_max,zm,mu,iq)
 cprint*,'Sortie vlx1'
 c	call minmaxq(zq,qmin,qmax,'apres vlx1    ')
 
 c print*,'Entree vly1'
-      call vly(zq,pente_max,zm,mv)
+
+      call vly(zq,pente_max,zm,mv,iq)
 c	call minmaxq(zq,qmin,qmax,'apres vly1     ')
 cprint*,'Sortie vly1'
-      call vlz(zq,pente_max,zm,mw)
+      call vlz(zq,pente_max,zm,mw,iq)
 c	call minmaxq(zq,qmin,qmax,'apres vlz     ')
 
 
-      call vly(zq,pente_max,zm,mv)
+      call vly(zq,pente_max,zm,mv,iq)
 c	call minmaxq(zq,qmin,qmax,'apres vly     ')
 
 
-      call vlx(zq,pente_max,zm,mu)
+      call vlx(zq,pente_max,zm,mu,iq)
 c	call minmaxq(zq,qmin,qmax,'apres vlx2    ')
 	
@@ -104,14 +115,29 @@
       DO l=1,llm
          DO ij=1,ip1jmp1
-           q(ij,l)=zq(ij,l)
+           q(ij,l,iq)=zq(ij,l,iq)
          ENDDO
          DO ij=1,ip1jm+1,iip1
-            q(ij+iim,l)=q(ij,l)
-         ENDDO
-      ENDDO
+            q(ij+iim,l,iq)=q(ij,l,iq)
+         ENDDO
+      ENDDO
+      ! CRisi: aussi pour les fils
+      if (nqdesc(iq).gt.0) then
+      do ifils=1,nqdesc(iq)
+        iq2=iqfils(ifils,iq)
+        DO l=1,llm
+         DO ij=1,ip1jmp1
+           q(ij,l,iq2)=zq(ij,l,iq2)
+         ENDDO
+         DO ij=1,ip1jm+1,iip1
+            q(ij+iim,l,iq2)=q(ij,l,iq2)
+         ENDDO
+        ENDDO
+      enddo !do ifils=1,nqdesc(iq)    
+      endif ! if (nqdesc(iq).gt.0) then    
 
       RETURN
       END
-      SUBROUTINE vlx(q,pente_max,masse,u_m)
+      RECURSIVE SUBROUTINE vlx(q,pente_max,masse,u_m,iq)
+      USE infotrac, ONLY : nqtot,nqfils,nqdesc,iqfils ! CRisi
 
 c     Auteurs:   P.Le Van, F.Hourdin, F.Forget 
@@ -133,8 +159,9 @@
 c   Arguments:
 c   ----------
-      REAL masse(ip1jmp1,llm),pente_max
+      REAL masse(ip1jmp1,llm,nqtot),pente_max
       REAL u_m( ip1jmp1,llm ),pbarv( iip1,jjm,llm)
-      REAL q(ip1jmp1,llm)
+      REAL q(ip1jmp1,llm,nqtot)
       REAL w(ip1jmp1,llm)
+      INTEGER iq ! CRisi
 c
 c      Local 
@@ -149,4 +176,8 @@
       REAL adxqu(ip1jmp1),dxqmax(ip1jmp1,llm)
       REAL u_mq(ip1jmp1,llm)
+
+      ! CRisi
+      REAL masseq(ip1jmp1,llm,nqtot),Ratio(ip1jmp1,llm,nqtot)
+      INTEGER ifils,iq2 ! CRisi
 
       Logical extremum,first,testcpu
@@ -182,7 +213,7 @@
          DO l = 1, llm
             DO ij=iip2,ip1jm-1
-               dxqu(ij)=q(ij+1,l)-q(ij,l)
+               dxqu(ij)=q(ij+1,l,iq)-q(ij,l,iq)
 c              IF(u_m(ij,l).lt.0.) stop'limx n admet pas les U<0'
-c              sigu(ij)=u_m(ij,l)/masse(ij,l)
+c              sigu(ij)=u_m(ij,l)/masse(ij,l,iq)
             ENDDO
             DO ij=iip1+iip1,ip1jm,iip1
@@ -237,5 +268,5 @@
          DO l = 1, llm
             DO ij=iip2,ip1jm-1
-               dxqu(ij)=q(ij+1,l)-q(ij,l)
+               dxqu(ij)=q(ij+1,l,iq)-q(ij,l,iq)
             ENDDO
             DO ij=iip1+iip1,ip1jm,iip1
@@ -279,11 +310,11 @@
       DO l=1,llm
        DO ij=iip2,ip1jm-1
-          zdum(ij,l)=cvmgp(1.-u_m(ij,l)/masse(ij,l),
-     ,                     1.+u_m(ij,l)/masse(ij+1,l),
+          zdum(ij,l)=cvmgp(1.-u_m(ij,l)/masse(ij,l,iq),
+     ,                     1.+u_m(ij,l)/masse(ij+1,l,iq),
      ,                     u_m(ij,l))
           zdum(ij,l)=0.5*zdum(ij,l)
           u_mq(ij,l)=cvmgp(
-     ,                q(ij,l)+zdum(ij,l)*dxq(ij,l),
-     ,                q(ij+1,l)-zdum(ij,l)*dxq(ij+1,l),
+     ,                q(ij,l,iq)+zdum(ij,l)*dxq(ij,l),
+     ,                q(ij+1,l,iq)-zdum(ij,l)*dxq(ij+1,l),
      ,                u_m(ij,l))
           u_mq(ij,l)=u_m(ij,l)*u_mq(ij,l)
@@ -297,11 +328,12 @@
       DO l=1,llm
        DO ij=iip2,ip1jm-1
-c	print*,'masse(',ij,')=',masse(ij,l)
+c	print*,'masse(',ij,')=',masse(ij,l,iq)
           IF (u_m(ij,l).gt.0.) THEN
-             zdum(ij,l)=1.-u_m(ij,l)/masse(ij,l)
-             u_mq(ij,l)=u_m(ij,l)*(q(ij,l)+0.5*zdum(ij,l)*dxq(ij,l))
+             zdum(ij,l)=1.-u_m(ij,l)/masse(ij,l,iq)
+             u_mq(ij,l)=u_m(ij,l)*(q(ij,l,iq)+0.5*zdum(ij,l)*dxq(ij,l))
           ELSE
-             zdum(ij,l)=1.+u_m(ij,l)/masse(ij+1,l)
-             u_mq(ij,l)=u_m(ij,l)*(q(ij+1,l)-0.5*zdum(ij,l)*dxq(ij+1,l))
+             zdum(ij,l)=1.+u_m(ij,l)/masse(ij+1,l,iq)
+             u_mq(ij,l)=u_m(ij,l)*(q(ij+1,l,iq)
+     &           -0.5*zdum(ij,l)*dxq(ij+1,l))
           ENDIF
        ENDDO
@@ -373,7 +405,8 @@
                      i=ijq-(j-1)*iip1
 c   accumulation pour les mailles completements advectees
-                     do while(zu_m.gt.masse(ijq,l))
-                        u_mq(ij,l)=u_mq(ij,l)+q(ijq,l)*masse(ijq,l)
-                        zu_m=zu_m-masse(ijq,l)
+                     do while(zu_m.gt.masse(ijq,l,iq))
+                        u_mq(ij,l)=u_mq(ij,l)+q(ijq,l,iq)
+     &                          *masse(ijq,l,iq)
+                        zu_m=zu_m-masse(ijq,l,iq)
                         i=mod(i-2+iim,iim)+1
                         ijq=(j-1)*iip1+i
@@ -381,18 +414,20 @@
 c   ajout de la maille non completement advectee
                      u_mq(ij,l)=u_mq(ij,l)+zu_m*
-     &               (q(ijq,l)+0.5*(1.-zu_m/masse(ijq,l))*dxq(ijq,l))
+     &                  (q(ijq,l,iq)+0.5*(1.-zu_m/masse(ijq,l,iq))
+     &                  *dxq(ijq,l))
                   ELSE
                      ijq=ij+1
                      i=ijq-(j-1)*iip1
 c   accumulation pour les mailles completements advectees
-                     do while(-zu_m.gt.masse(ijq,l))
-                        u_mq(ij,l)=u_mq(ij,l)-q(ijq,l)*masse(ijq,l)
-                        zu_m=zu_m+masse(ijq,l)
+                     do while(-zu_m.gt.masse(ijq,l,iq))
+                        u_mq(ij,l)=u_mq(ij,l)-q(ijq,l,iq)
+     &                          *masse(ijq,l,iq)
+                        zu_m=zu_m+masse(ijq,l,iq)
                         i=mod(i,iim)+1
                         ijq=(j-1)*iip1+i
                      ENDDO
 c   ajout de la maille non completement advectee
-                     u_mq(ij,l)=u_mq(ij,l)+zu_m*(q(ijq,l)-
-     &               0.5*(1.+zu_m/masse(ijq,l))*dxq(ijq,l))
+                     u_mq(ij,l)=u_mq(ij,l)+zu_m*(q(ijq,l,iq)-
+     &               0.5*(1.+zu_m/masse(ijq,l,iq))*dxq(ijq,l))
                   ENDIF
                ENDDO
@@ -411,4 +446,26 @@
       ENDDO
 
+! CRisi: appel récursif de l'advection sur les fils.
+! Il faut faire ça avant d'avoir mis à jour q et masse
+      !write(*,*) 'vlsplt 326: iq,nqfils(iq)=',iq,nqfils(iq) 
+      
+      if (nqdesc(iq).gt.0) then  
+       do ifils=1,nqdesc(iq)
+         iq2=iqfils(ifils,iq)
+         DO l=1,llm
+          DO ij=iip2,ip1jm
+           ! On a besoin de q et masse seulement entre iip2 et ip1jm 
+           masseq(ij,l,iq2)=masse(ij,l,iq)*q(ij,l,iq)
+           Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
+          enddo   
+         enddo
+        enddo !do ifils=1,nqdesc(iq)
+        do ifils=1,nqfils(iq)
+         iq2=iqfils(ifils,iq)
+         call vlx(Ratio,pente_max,masseq,u_mq,iq2)
+        enddo !do ifils=1,nqfils(iq)
+      endif !if (nqfils(iq).gt.0) then
+! end CRisi
+
 
 c   calcul des tENDances
@@ -416,16 +473,34 @@
       DO l=1,llm
          DO ij=iip2+1,ip1jm
-            new_m=masse(ij,l)+u_m(ij-1,l)-u_m(ij,l)
-            q(ij,l)=(q(ij,l)*masse(ij,l)+
+            new_m=masse(ij,l,iq)+u_m(ij-1,l)-u_m(ij,l)
+            q(ij,l,iq)=(q(ij,l,iq)*masse(ij,l,iq)+
      &      u_mq(ij-1,l)-u_mq(ij,l))
      &      /new_m
-            masse(ij,l)=new_m
+            masse(ij,l,iq)=new_m
          ENDDO
 c   ModIF Fred 22 03 96 correction d'un bug (les scopy ci-dessous)
          DO ij=iip1+iip1,ip1jm,iip1
-            q(ij-iim,l)=q(ij,l)
-            masse(ij-iim,l)=masse(ij,l)
-         ENDDO
-      ENDDO
+            q(ij-iim,l,iq)=q(ij,l,iq)
+            masse(ij-iim,l,iq)=masse(ij,l,iq)
+         ENDDO
+      ENDDO
+
+      ! retablir les fils en rapport de melange par rapport a l'air:
+      ! On calcule q entre iip2+1,ip1jm -> on fait pareil pour ratio 
+      ! puis on boucle en longitude
+      if (nqdesc(iq).gt.0) then  
+       do ifils=1,nqdesc(iq)
+         iq2=iqfils(ifils,iq)  
+         DO l=1,llm
+          DO ij=iip2+1,ip1jm
+            q(ij,l,iq2)=q(ij,l,iq)*Ratio(ij,l,iq2)            
+          enddo
+          DO ij=iip1+iip1,ip1jm,iip1
+             q(ij-iim,l,iq2)=q(ij,l,iq2)
+          enddo ! DO ij=ijb+iip1-1,ije,iip1
+         enddo !DO l=1,llm
+        enddo !do ifils=1,nqdesc(iq)
+      endif !if (nqfils(iq).gt.0) then
+
 c     CALL SCOPY((jjm-1)*llm,q(iip1+iip1,1),iip1,q(iip2,1),iip1)
 c     CALL SCOPY((jjm-1)*llm,masse(iip1+iip1,1),iip1,masse(iip2,1),iip1)
@@ -434,5 +509,7 @@
       RETURN
       END
-      SUBROUTINE vly(q,pente_max,masse,masse_adv_v)
+      RECURSIVE SUBROUTINE vly(q,pente_max,masse,masse_adv_v,iq)
+      USE infotrac, ONLY : nqtot,nqfils,nqdesc,iqfils ! CRisi
+      USE comconst_mod, ONLY: pi
 c
 c     Auteurs:   P.Le Van, F.Hourdin, F.Forget 
@@ -446,6 +523,4 @@
 c
 c   --------------------------------------------------------------------
-      USE comconst_mod, ONLY: pi
-
       IMPLICIT NONE
 c
@@ -457,7 +532,8 @@
 c   Arguments:
 c   ----------
-      REAL masse(ip1jmp1,llm),pente_max
+      REAL masse(ip1jmp1,llm,nqtot),pente_max
       REAL masse_adv_v( ip1jm,llm)
-      REAL q(ip1jmp1,llm), dq( ip1jmp1,llm)
+      REAL q(ip1jmp1,llm,nqtot), dq( ip1jmp1,llm)
+      INTEGER iq ! CRisi
 c
 c      Local 
@@ -484,4 +560,8 @@
       SAVE sinlon,coslon,sinlondlon,coslondlon
       SAVE airej2,airejjm
+
+      REAL masseq(ip1jmp1,llm,nqtot),Ratio(ip1jmp1,llm,nqtot) ! CRisi
+      INTEGER ifils,iq2 ! CRisi
+
 c
 c
@@ -490,4 +570,6 @@
       DATA first,testcpu/.true.,.false./
       DATA temps0,temps1,temps2,temps3,temps4,temps5/0.,0.,0.,0.,0.,0./
+
+      !write(*,*) 'vly 578: entree, iq=',iq
 
       IF(first) THEN
@@ -522,6 +604,6 @@
 
       DO i = 1, iim
-      airescb(i) = aire(i+ iip1) * q(i+ iip1,l)
-      airesch(i) = aire(i+ ip1jm- iip1) * q(i+ ip1jm- iip1,l)
+      airescb(i) = aire(i+ iip1) * q(i+ iip1,l,iq)
+      airesch(i) = aire(i+ ip1jm- iip1) * q(i+ ip1jm- iip1,l,iq)
       ENDDO
       qpns   = SSUM( iim,  airescb ,1 ) / airej2
@@ -531,5 +613,5 @@
 
       DO ij=1,ip1jm
-         dyqv(ij)=q(ij,l)-q(ij+iip1,l)
+         dyqv(ij)=q(ij,l,iq)-q(ij+iip1,l,iq)
          adyqv(ij)=abs(dyqv(ij))
       ENDDO
@@ -546,6 +628,6 @@
 
       DO ij=1,iip1
-         dyq(ij,l)=qpns-q(ij+iip1,l)
-         dyq(ip1jm+ij,l)=q(ip1jm+ij-iip1,l)-qpsn
+         dyq(ij,l)=qpns-q(ij+iip1,l,iq)
+         dyq(ip1jm+ij,l)=q(ip1jm+ij-iip1,l,iq)-qpsn
       ENDDO
 
@@ -668,12 +750,15 @@
       ENDDO
 
+      !write(*,*) 'vly 756'
       DO l=1,llm
        DO ij=1,ip1jm
           IF(masse_adv_v(ij,l).gt.0) THEN
-              qbyv(ij,l)=q(ij+iip1,l)+dyq(ij+iip1,l)*
-     ,                   0.5*(1.-masse_adv_v(ij,l)/masse(ij+iip1,l))
+              qbyv(ij,l)=q(ij+iip1,l,iq)+dyq(ij+iip1,l)*
+     ,                   0.5*(1.-masse_adv_v(ij,l)
+     ,                   /masse(ij+iip1,l,iq))
           ELSE
-              qbyv(ij,l)=q(ij,l)-dyq(ij,l)*
-     ,                   0.5*(1.+masse_adv_v(ij,l)/masse(ij,l))
+              qbyv(ij,l)=q(ij,l,iq)-dyq(ij,l)*
+     ,                   0.5*(1.+masse_adv_v(ij,l)
+     ,                   /masse(ij,l,iq))
           ENDIF
           qbyv(ij,l)=masse_adv_v(ij,l)*qbyv(ij,l)
@@ -681,12 +766,34 @@
       ENDDO
 
+! CRisi: appel récursif de l'advection sur les fils.
+! Il faut faire ça avant d'avoir mis à jour q et masse
+      !write(*,*) 'vly 689: iq,nqfils(iq)=',iq,nqfils(iq) 
+   
+      if (nqfils(iq).gt.0) then  
+       do ifils=1,nqdesc(iq)
+         iq2=iqfils(ifils,iq)
+         DO l=1,llm
+         DO ij=1,ip1jmp1
+           ! attention, chaque fils doit avoir son masseq, sinon, le 1er
+           ! fils ecrase le masseq de ses freres.
+           masseq(ij,l,iq2)=masse(ij,l,iq)*q(ij,l,iq)
+           Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)     
+          enddo   
+         enddo
+        enddo !do ifils=1,nqdesc(iq)
+
+        do ifils=1,nqfils(iq)
+         iq2=iqfils(ifils,iq)
+         call vly(Ratio,pente_max,masseq,qbyv,iq2)
+        enddo !do ifils=1,nqfils(iq)
+      endif !if (nqfils(iq).gt.0) then
 
       DO l=1,llm
          DO ij=iip2,ip1jm
-            newmasse=masse(ij,l)
+            newmasse=masse(ij,l,iq)
      &      +masse_adv_v(ij,l)-masse_adv_v(ij-iip1,l)
-            q(ij,l)=(q(ij,l)*masse(ij,l)+qbyv(ij,l)-qbyv(ij-iip1,l))
-     &         /newmasse
-            masse(ij,l)=newmasse
+            q(ij,l,iq)=(q(ij,l,iq)*masse(ij,l,iq)+qbyv(ij,l)
+     &         -qbyv(ij-iip1,l))/newmasse
+            masse(ij,l,iq)=newmasse
          ENDDO
 c.-. ancienne version
@@ -696,12 +803,12 @@
          convpn=SSUM(iim,qbyv(1,l),1)
          convmpn=ssum(iim,masse_adv_v(1,l),1)
-         massepn=ssum(iim,masse(1,l),1)
+         massepn=ssum(iim,masse(1,l,iq),1)
          qpn=0.
          do ij=1,iim
-            qpn=qpn+masse(ij,l)*q(ij,l)
+            qpn=qpn+masse(ij,l,iq)*q(ij,l,iq)
          enddo
          qpn=(qpn+convpn)/(massepn+convmpn)
          do ij=1,iip1
-            q(ij,l)=qpn
+            q(ij,l,iq)=qpn
          enddo
 
@@ -711,12 +818,12 @@
          convps=-SSUM(iim,qbyv(ip1jm-iim,l),1)
          convmps=-ssum(iim,masse_adv_v(ip1jm-iim,l),1)
-         masseps=ssum(iim, masse(ip1jm+1,l),1)
+         masseps=ssum(iim, masse(ip1jm+1,l,iq),1)
          qps=0.
          do ij = ip1jm+1,ip1jmp1-1
-            qps=qps+masse(ij,l)*q(ij,l)
+            qps=qps+masse(ij,l,iq)*q(ij,l,iq)
          enddo
          qps=(qps+convps)/(masseps+convmps)
          do ij=ip1jm+1,ip1jmp1
-            q(ij,l)=qps
+            q(ij,l,iq)=qps
          enddo
 
@@ -732,5 +839,5 @@
 c        DO ij = 1,iip1
 c           q(ij,l)=newq
-c           masse(ij,l)=newmasse*aire(ij)
+c           masse(ij,l,iq)=newmasse*aire(ij)
 c        ENDDO
 c        convps=-SSUM(iim,qbyv(ip1jm-iim,l),1)
@@ -742,12 +849,27 @@
 c        DO ij = ip1jm+1,ip1jmp1
 c           q(ij,l)=newq
-c           masse(ij,l)=newmasse*aire(ij)
+c           masse(ij,l,iq)=newmasse*aire(ij)
 c        ENDDO
 c._. fin nouvelle version
       ENDDO
+  
+! retablir les fils en rapport de melange par rapport a l'air:
+      if (nqfils(iq).gt.0) then  
+       do ifils=1,nqdesc(iq)
+         iq2=iqfils(ifils,iq)  
+         DO l=1,llm
+          DO ij=1,ip1jmp1
+            q(ij,l,iq2)=q(ij,l,iq)*Ratio(ij,l,iq2)            
+          enddo
+         enddo
+        enddo !do ifils=1,nqdesc(iq)
+      endif !if (nqfils(iq).gt.0) then
+
+      !write(*,*) 'vly 853: sortie'
 
       RETURN
       END
-      SUBROUTINE vlz(q,pente_max,masse,w)
+      RECURSIVE SUBROUTINE vlz(q,pente_max,masse,w,iq)
+      USE infotrac, ONLY : nqtot,nqfils,nqdesc,iqfils ! CRisi 
 c
 c     Auteurs:   P.Le Van, F.Hourdin, F.Forget 
@@ -769,7 +891,8 @@
 c   Arguments:
 c   ----------
-      REAL masse(ip1jmp1,llm),pente_max
-      REAL q(ip1jmp1,llm)
+      REAL masse(ip1jmp1,llm,nqtot),pente_max
+      REAL q(ip1jmp1,llm,nqtot)
       REAL w(ip1jmp1,llm+1)
+      INTEGER iq
 c
 c      Local 
@@ -782,4 +905,7 @@
       REAL dzq(ip1jmp1,llm),dzqw(ip1jmp1,llm),adzqw(ip1jmp1,llm),dzqmax
       REAL sigw
+
+      REAL masseq(ip1jmp1,llm,nqtot),Ratio(ip1jmp1,llm,nqtot) ! CRisi
+      INTEGER ifils,iq2 ! CRisi
 
       LOGICAL testcpu
@@ -795,4 +921,6 @@
 c    On oriente tout dans le sens de la pression c'est a dire dans le
 c    sens de W
+
+      !write(*,*) 'vlz 923: entree'
 
 #ifdef BIDON
@@ -803,5 +931,5 @@
       DO l=2,llm
          DO ij=1,ip1jmp1
-            dzqw(ij,l)=q(ij,l-1)-q(ij,l)
+            dzqw(ij,l)=q(ij,l-1,iq)-q(ij,l,iq)
             adzqw(ij,l)=abs(dzqw(ij,l))
          ENDDO
@@ -825,4 +953,5 @@
       ENDDO
 
+      !write(*,*) 'vlz 954'
       DO ij=1,ip1jmp1
          dzq(ij,1)=0.
@@ -841,12 +970,14 @@
 c calcul de  - d( q   * w )/ d(sigma)    qu'on ajoute a  dq pour calculer dq
 
+       !write(*,*) 'vlz 969'
        DO l = 1,llm-1
          do  ij = 1,ip1jmp1
           IF(w(ij,l+1).gt.0.) THEN
-             sigw=w(ij,l+1)/masse(ij,l+1)
-             wq(ij,l+1)=w(ij,l+1)*(q(ij,l+1)+0.5*(1.-sigw)*dzq(ij,l+1))
+             sigw=w(ij,l+1)/masse(ij,l+1,iq)
+             wq(ij,l+1)=w(ij,l+1)*(q(ij,l+1,iq)
+     &           +0.5*(1.-sigw)*dzq(ij,l+1))
           ELSE
-             sigw=w(ij,l+1)/masse(ij,l)
-             wq(ij,l+1)=w(ij,l+1)*(q(ij,l)-0.5*(1.+sigw)*dzq(ij,l))
+             sigw=w(ij,l+1)/masse(ij,l,iq)
+             wq(ij,l+1)=w(ij,l+1)*(q(ij,l,iq)-0.5*(1.+sigw)*dzq(ij,l))
           ENDIF
          ENDDO
@@ -858,13 +989,46 @@
        ENDDO
 
+! CRisi: appel récursif de l'advection sur les fils.
+! Il faut faire ça avant d'avoir mis à jour q et masse
+      !write(*,*) 'vlsplt 942: iq,nqfils(iq)=',iq,nqfils(iq)
+      if (nqfils(iq).gt.0) then  
+       do ifils=1,nqdesc(iq)
+         iq2=iqfils(ifils,iq)
+         DO l=1,llm
+          DO ij=1,ip1jmp1
+           masseq(ij,l,iq2)=masse(ij,l,iq)*q(ij,l,iq)
+           Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)        
+          enddo   
+         enddo
+        enddo !do ifils=1,nqdesc(iq)
+        
+        do ifils=1,nqfils(iq)
+         iq2=iqfils(ifils,iq)         
+         call vlz(Ratio,pente_max,masseq,wq,iq2)
+        enddo !do ifils=1,nqfils(iq)
+      endif !if (nqfils(iq).gt.0) then
+! end CRisi  
+
       DO l=1,llm
          DO ij=1,ip1jmp1
-            newmasse=masse(ij,l)+w(ij,l+1)-w(ij,l)
-            q(ij,l)=(q(ij,l)*masse(ij,l)+wq(ij,l+1)-wq(ij,l))
+            newmasse=masse(ij,l,iq)+w(ij,l+1)-w(ij,l)
+            q(ij,l,iq)=(q(ij,l,iq)*masse(ij,l,iq)+wq(ij,l+1)-wq(ij,l))
      &         /newmasse
-            masse(ij,l)=newmasse
-         ENDDO
-      ENDDO
-
+            masse(ij,l,iq)=newmasse
+         ENDDO
+      ENDDO
+
+! retablir les fils en rapport de melange par rapport a l'air:
+      if (nqfils(iq).gt.0) then  
+       do ifils=1,nqdesc(iq)
+         iq2=iqfils(ifils,iq)  
+         DO l=1,llm
+          DO ij=1,ip1jmp1
+            q(ij,l,iq2)=q(ij,l,iq)*Ratio(ij,l,iq2)            
+          enddo
+         enddo
+        enddo !do ifils=1,nqdesc(iq)
+      endif !if (nqfils(iq).gt.0) then
+      !write(*,*) 'vlsplt 1032'
 
       RETURN
